/* 
   Copyright (C) 2004-2006 Teksoft SRL Romania
   
   THIS SOURCE CODE IS PROPERTY OF Teksoft SRL Romania.
   http://www.teksoftco.com
   All rights reserved.

Description:
============
RadioDevices sample offers the possibility of controlling the Radio Devices (Phone,Bluetooth,WiFi),
on devices running Windows CE for Pocket PC 4.0 and Windows CE for Pocket PC 5.0

License:
========
Redistribution and use in source and binary forms, with or without modification, are permitted 
provided that the following conditions are met (1,2,3): 
1) Redistribution of source code is not allowed in any way, nor is allowed selling the source code 
and this library to other parties.
2) Redistribution in binary form must reproduce the above copyright notice, this list of conditions 
and the following disclaimer in the documentation and/or other materials provided with the 
distribution. 
3) Neither the name of Teksoft SRL Romania or the names of contributors may be used to endorse 
or promote products derived from this software without specific prior written permission. 

This software is provided "AS IS," without a warranty of any kind. ALL EXPRESS OR IMPLIED 
CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. Teksoft SRL Romania 
("Teksoft") AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT 
OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL Teksoft OR 
ITS LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL, 
CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF 
LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE THIS SOFTWARE, EVEN IF Teksoft HAS BEEN 
ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. 
*/

// RadioDevices.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "RadioDevices.h"
#include <windows.h>
#include <commctrl.h>
#include "WirelessDevices.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE			g_hInst;			// current instance
HWND				g_hWndMenuBar;		// menu bar handle
TCHAR				szText[260];		// text to display radio devices

// Forward declarations of functions included in this code module:
ATOM			MyRegisterClass(HINSTANCE, LPTSTR);
BOOL			InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
	MSG msg;

	// Load ossvcs.dll
	InitDLL();

	// Perform application initialization:
	if (!InitInstance(hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	HACCEL hAccelTable;
	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_RADIODEVICES));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	// Free ossvcs.dll
	DeinitDLL();

	return (int) msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS wc;

	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_RADIODEVICES));
	wc.hCursor       = 0;
	wc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName  = 0;
	wc.lpszClassName = szWindowClass;

	return RegisterClass(&wc);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
    HWND hWnd;
    TCHAR szTitle[MAX_LOADSTRING];		// title bar text
    TCHAR szWindowClass[MAX_LOADSTRING];	// main window class name

    g_hInst = hInstance; // Store instance handle in our global variable

    // SHInitExtraControls should be called once during your application's initialization to initialize any
    // of the device specific controls such as CAPEDIT and SIPPREF.
    SHInitExtraControls();

    LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING); 
    LoadString(hInstance, IDC_RADIODEVICES, szWindowClass, MAX_LOADSTRING);

    //If it is already running, then focus on the window, and exit
    hWnd = FindWindow(szWindowClass, szTitle);	
    if (hWnd) 
    {
        // set focus to foremost child window
        // The "| 0x00000001" is used to bring any owned windows to the foreground and
        // activate them.
        SetForegroundWindow((HWND)((ULONG) hWnd | 0x00000001));
        return 0;
    } 

    if (!MyRegisterClass(hInstance, szWindowClass))
    {
    	return FALSE;
    }

    hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

    if (!hWnd)
    {
        return FALSE;
    }
	// Create Child controls
	CreateWindow(TEXT("button"),TEXT("All ON"),WS_VISIBLE | WS_CHILD | BS_PUSHBUTTON,
		10,10,220,20,
		hWnd,(HMENU)IDB_ALLON,hInstance,0);
	CreateWindow(TEXT("button"),TEXT("All OFF"),WS_VISIBLE | WS_CHILD | BS_PUSHBUTTON,
		10,40,220,20,
		hWnd,(HMENU)IDB_ALLOFF,hInstance,0);
    // When the main window is created using CW_USEDEFAULT the height of the menubar (if one
    // is created is not taken into account). So we resize the window after creating it
    // if a menubar is present
    if (g_hWndMenuBar)
    {
        RECT rc;
        RECT rcMenuBar;

        GetWindowRect(hWnd, &rc);
        GetWindowRect(g_hWndMenuBar, &rcMenuBar);
        rc.bottom -= (rcMenuBar.bottom - rcMenuBar.top);
		
        MoveWindow(hWnd, rc.left, rc.top, rc.right-rc.left, rc.bottom-rc.top, FALSE);
    }

    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);


    return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int wmId, wmEvent;
    PAINTSTRUCT ps;
    HDC hdc;

    static SHACTIVATEINFO s_sai;
	
    switch (message) 
    {
        case WM_COMMAND:
            wmId    = LOWORD(wParam); 
            wmEvent = HIWORD(wParam); 
            // Parse the menu selections:
            switch (wmId)
            {
				case IDB_ALLON:
					//start bluetooth
					SetWDevState( RADIODEVICES_BLUETOOTH, 1);
					//start phone
					SetWDevState( RADIODEVICES_PHONE, 1);
					//start WIFI
					SetWDevState( RADIODEVICES_MANAGED, 1);
				break;
				case IDB_ALLOFF:
					//stop bluetooth
					SetWDevState( RADIODEVICES_BLUETOOTH, 0);
					//stop phone
					SetWDevState( RADIODEVICES_PHONE, 0);
					//stop WIFI
					SetWDevState( RADIODEVICES_MANAGED, 0);
				break;
                case IDM_HELP_ABOUT:
                    MessageBox(hWnd,TEXT("Radio Devices Sample\n(C)2006 , Teksoft SRL\nwww.teksoftco.com\n\nVisit\nwww.teksoftco.com/forum\nfor other interesting samples or articles!"),
						TEXT("About"),MB_ICONINFORMATION);
                    break;
                case IDM_OK:
                    SendMessage (hWnd, WM_CLOSE, 0, 0);				
                    break;
                default:
                    return DefWindowProc(hWnd, message, wParam, lParam);
            }
            break;
        case WM_CREATE:
            SHMENUBARINFO mbi;

            memset(&mbi, 0, sizeof(SHMENUBARINFO));
            mbi.cbSize     = sizeof(SHMENUBARINFO);
            mbi.hwndParent = hWnd;
            mbi.nToolBarId = IDR_MENU;
            mbi.hInstRes   = g_hInst;

            if (!SHCreateMenuBar(&mbi)) 
            {
                g_hWndMenuBar = NULL;
            }
            else
            {
                g_hWndMenuBar = mbi.hwndMB;
            }

            // Initialize the shell activate info structure
            memset(&s_sai, 0, sizeof (s_sai));
            s_sai.cbSize = sizeof (s_sai);
			// Set timer to check for Radio Devices
			SetTimer(hWnd, 1230, 2000, 0);
			_tcscpy(szText,TEXT("Checking the state of the Radio Devices"));
            break;
		case WM_TIMER:
			DWORD	dwWifi, dwPhone, dwBT;
			GetWDevState(&dwWifi, &dwPhone, &dwBT);
			_stprintf(szText,TEXT("Bluetooth:[%s] Phone:[%s] WiFi:[%s]"),
				((dwBT == 1) || (dwBT == 2))?TEXT("ON"):TEXT("OFF"),
				(dwPhone == 1)?TEXT("ON"):TEXT("OFF"),
				(dwWifi == 1)?TEXT("ON"):TEXT("OFF")
				);
			InvalidateRect(hWnd,0,0);
			break;
				
        case WM_PAINT:
			{
            hdc = BeginPaint(hWnd, &ps);
            
            // TODO: Add any drawing code here...
            RECT rt;
			GetClientRect(hWnd, &rt);
			rt.top = (rt.bottom - rt.top)/2;

			DrawText(hdc,szText,-1,&rt,DT_CENTER | DT_WORDBREAK);
            EndPaint(hWnd, &ps);
			}
            break;
        case WM_DESTROY:
            CommandBar_Destroy(g_hWndMenuBar);
            PostQuitMessage(0);
            break;

        case WM_ACTIVATE:
            // Notify shell of our activate message
            SHHandleWMActivate(hWnd, wParam, lParam, &s_sai, FALSE);
            break;
        case WM_SETTINGCHANGE:
            SHHandleWMSettingChange(hWnd, wParam, lParam, &s_sai);
            break;

        default:
            return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return 0;
}

